/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 2011 Oracle and/or its affiliates. All rights reserved.
 *
 * Oracle and Java are registered trademarks of Oracle and/or its affiliates.
 * Other names may be trademarks of their respective owners.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Oracle designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Oracle in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 *
 * Contributor(s):
 *
 * Portions Copyrighted 2011 Sun Microsystems, Inc.
 */
package org.netbeans.modules.php.project.phpunit.ui;

import javax.swing.JPanel;
import javax.swing.table.DefaultTableModel;
import org.openide.util.NbBundle;

/**
 * UI for selecting PhpUnit test groups.
 */
public class PhpUnitTestGroupsPanel extends JPanel {

    private static final long serialVersionUID = 6576832132135L;

    private final DefaultTableModel tableModel;

    public PhpUnitTestGroupsPanel(DefaultTableModel tableModel) {
        this.tableModel = tableModel;

        initComponents();

        selectAllTestGroupsCheckBox.setText(NbBundle.getMessage(PhpUnitTestGroupsPanel.class, "LBL_SelectAllTestGroups"));
        testGroupsTable.setTableHeader(null);
        setFocusable(true);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        testGroupsScrollPane = new javax.swing.JScrollPane();
        testGroupsTable = new javax.swing.JTable();
        selectTestGroupLabel = new javax.swing.JLabel();
        selectAllTestGroupsCheckBox = new javax.swing.JCheckBox();

        testGroupsTable.setModel(tableModel);
        testGroupsTable.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_NEXT_COLUMN);
        testGroupsTable.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        testGroupsScrollPane.setViewportView(testGroupsTable);

        selectTestGroupLabel.setText(org.openide.util.NbBundle.getMessage(PhpUnitTestGroupsPanel.class, "PhpUnitTestGroupsPanel.selectTestGroupLabel.text")); // NOI18N

        selectAllTestGroupsCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                selectAllTestGroupsCheckBoxActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(testGroupsScrollPane, javax.swing.GroupLayout.DEFAULT_SIZE, 346, Short.MAX_VALUE)
                    .addComponent(selectTestGroupLabel)
                    .addComponent(selectAllTestGroupsCheckBox, javax.swing.GroupLayout.Alignment.TRAILING))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(selectTestGroupLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(testGroupsScrollPane, javax.swing.GroupLayout.DEFAULT_SIZE, 90, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(selectAllTestGroupsCheckBox))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void selectAllTestGroupsCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_selectAllTestGroupsCheckBoxActionPerformed
        Boolean selectAllGroups = null;
        String labelSelector = null;
        if (selectAllTestGroupsCheckBox.isSelected()) {
            selectAllGroups = Boolean.TRUE;
            labelSelector = "LBL_SelectNoTestGroups"; // NOI18N
        } else {
            selectAllGroups = Boolean.FALSE;
            labelSelector = "LBL_SelectAllTestGroups"; // NOI18N
        }

        for (int i = 0; i < tableModel.getRowCount(); i++) {
            tableModel.setValueAt(selectAllGroups, i, 1);
        }
        selectAllTestGroupsCheckBox.setText(NbBundle.getMessage(PhpUnitTestGroupsPanel.class, labelSelector));
    }//GEN-LAST:event_selectAllTestGroupsCheckBoxActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox selectAllTestGroupsCheckBox;
    private javax.swing.JLabel selectTestGroupLabel;
    private javax.swing.JScrollPane testGroupsScrollPane;
    private javax.swing.JTable testGroupsTable;
    // End of variables declaration//GEN-END:variables
}
